# encoding: utf
#
# Задача "Башни кубиков"
# Пятая личная Интернет-олимпиада сезона 2010-2011
# Автор задачи: Владимир Ульянцев, ulyantsev@rain.ifmo.ru
# Автор решения: Владимир Ульянцев, ulyantsev@rain.ifmo.ru

with open('cubics.in') as inf:
    n, k = [int(s) for s in inf.readline().split()]
    a = [int(s) - k for s in inf.readline().split()]
    assert len(a) == n

sum, d, ans = 0, {0: -1}, (-1, -1)
for i in xrange(n):
    sum += a[i]
    
    if sum not in d:
        d[sum] = i
    elif i - d[sum] > ans[0]:
        ans = (i - d[sum], d[sum])

print >>open('cubics.out', 'w'), str(ans[0]) + ' ' + str(ans[1] + 2) if ans[0] > 0 else '0'
    